

#if !defined (__CHAIN_H)
#define __CHAIN_H

#include "quark.h"


/* *************************************************************
************************************************************* */
class chain : public quark {

   protected:
      vector4f endpt;
      vector3f color[2];
      float intensity, cintensity, decay, death;

   public:

      // superclass
      int  query_whatami() { return OBJECT_CHAIN; }
      int  query_whatwasi(int type);
      int  parse(FILE *infile, char *token);

      // quark
      void setup();
      void begin(dbl_llist_manager *hiearchy_manager, quark *parent, vector4f *mx);
      void whereami(dbl_llist_manager *hiearchy_manager, quark *parent, vector4f *mx);

      // chain
      chain();
      virtual ~chain() {}
};


/* *************************************************************
************************************************************* */
class chain_loader : public quark_loader {

   public:
      superclass *make_object() { return new chain; }
      chain_loader() {
         object_name = TOKEN_CHAIN_STR;
         alias_name = TOKEN_LINE_STR;
      }

      virtual ~chain_loader() {}
};


#endif

