



#if !defined __RADIANT_H
#define __RADIANT_H

#include "base.h"

/* *************************************************************
************************************************************* */
class radiant : public pc {

   protected:
   
      // pc
      void  transform(eye *parm);
      int clip(eye *parm, int maxx, int maxy);

      // radiant
      float wradius, winner_circle, wratio, tradius, sqrwradius, scale;
      vector4f wcenter;
      int   row[2], col[2];

      pc *r;

      float radiance(float pt[]);

   public:
      // superclass
      int  query_whatami() { return OBJECT_RADIANT; }
      int  query_whatwasi(int type);
      int  parse(FILE *infile, char *token);
      void preprocess(void *data);

      // frameclass
      int  dump_frame(FILE *outfile);
      
      // pc
      int  bound_box(eye *parm);
      void bound_sphere();
      void datacopy();
      void end_scan() { if (r) delete r; }

      int scan(camera *cparm, light *lmain, engine *proc);
      int beamscan(spotlight *spot, engine *proc);

      void render(camera *cparm, light *lmain, light *spot, engine *proc);
      void prender(engine *proc);
      void beamrender(spotlight *spot, engine *proc);

      // radiant
      int   flagh;
      float radius, inner_circle;

      radiant() {
         inner_circle = 1;
         radius = 2;
         mcinfo.mask_replace(CITRANSPARENT);

         flagh = 0;
         r = NULL;
      }

      virtual ~radiant() {}
};

typedef radiant * pradiant;

/* *************************************************************
************************************************************* */
class radiant_loader : public loader {

   public:
      superclass *make_object() { return new radiant; }
      radiant_loader() {object_name = TOKEN_RADIANT_STR; }
      virtual ~radiant_loader() {}
};


#endif

